package HalfMonthlyArchives::Util;
use strict;
use base qw( Exporter );

our @EXPORT_OK = qw( first_half_label last_half_label ts2half start_end_half_month );

sub first_half_label {
    my $plugin = MT::Plugin::HalfMonthlyArchives->instance;
    $plugin->get_config_value('first_half_label') || 'a';
}

sub last_half_label {
    my $plugin = MT::Plugin::HalfMonthlyArchives->instance;
    $plugin->get_config_value('last_half_label') || 'b';
}

sub ts2half {
    my ($ts) = @_;
    my ($y, $m, $d) = unpack('A4A2A2', $ts);
    my $start_lasthalf = 16;
    my $hm = 16;
    $hm = 1 if $d < $start_lasthalf;
    $hm;
}

sub start_end_half_month {
    my($ts) = @_;
    my($y, $mo) = unpack 'A4A2', $ts;
    my $start;
    if (ts2half($ts) == 1) {
        $start = sprintf "%04d%02d01000000", $y, $mo;
    } else {
        $start = sprintf "%04d%02d16000000", $y, $mo;
    }
    return $start unless wantarray;
    my $end;
    if (ts2half($ts) == 1) {
        require MT::Util;
        $end = sprintf "%04d%02d15235959", $y, $mo, MT::Util::days_in($mo, $y);
    } else {
        require MT::Util;
        $end = sprintf "%04d%02d%02d235959", $y, $mo, MT::Util::days_in($mo, $y);
    }
    ($start, $end);
}

1;
